Index: main/waeup.ikoba/trunk/src/waeup/ikoba/customers/browser.py
===================================================================
--- main/waeup.ikoba/trunk/src/waeup/ikoba/customers/browser.py	(revision 12220)
+++ main/waeup.ikoba/trunk/src/waeup/ikoba/customers/browser.py	(revision 12221)
@@ -229,5 +229,5 @@
         self.applyData(customer, **data)
         self.context.addCustomer(customer)
-        self.flash(_('Customer record created.'))
+        self.flash(_('Customer created.'))
         self.redirect(self.url(self.context[customer.customer_id], 'index'))
         return
@@ -525,5 +525,5 @@
                 # know that a record was found and only the firstname
                 # verification failed.
-                self.flash(_('No customer record found.'), type="warning")
+                self.flash(_('No customer found.'), type="warning")
                 return
             elif customer.password is not None and self._pw_used:
@@ -537,5 +537,5 @@
         else:
             # No record found, this is the truth.
-            self.flash(_('No customer record found.'), type="warning")
+            self.flash(_('No customer found.'), type="warning")
             return
 
Index: main/waeup.ikoba/trunk/src/waeup/ikoba/customers/tests/test_browser.py
===================================================================
--- main/waeup.ikoba/trunk/src/waeup/ikoba/customers/tests/test_browser.py	(revision 12220)
+++ main/waeup.ikoba/trunk/src/waeup/ikoba/customers/tests/test_browser.py	(revision 12221)
@@ -140,6 +140,4 @@
         self.contracts_path = self.customer_path + '/contracts'
 
-        self.app['configuration'].carry_over = True
-
         # Update the catalog
         notify(grok.ObjectModifiedEvent(self.customer))
@@ -195,6 +193,6 @@
             in self.browser.contents)
         self.browser.getControl(name="form.reg_number").value = '1234'
-        self.browser.getControl("Create customer record").click()
-        self.assertTrue('Customer record created' in self.browser.contents)
+        self.browser.getControl("Create customer").click()
+        self.assertTrue('Customer created' in self.browser.contents)
 
         # Registration must be unique
@@ -604,5 +602,5 @@
         # Customer can view history
         self.browser.getLink("History").click()
-        self.assertMatches('...Customer record created by system...',
+        self.assertMatches('...Customer created by system...',
             self.browser.contents)
 
@@ -694,5 +692,5 @@
         self.browser.getControl(name="form.email").value = 'xx@yy.zz'
         self.browser.getControl("Send login credentials").click()
-        self.assertTrue('No customer record found.'
+        self.assertTrue('No customer found.'
             in self.browser.contents)
         # Anonymous is not informed that firstname verification failed.
@@ -703,5 +701,5 @@
         self.browser.getControl(name="form.email").value = 'xx@yy.zz'
         self.browser.getControl("Send login credentials").click()
-        self.assertTrue('No customer record found.'
+        self.assertTrue('No customer found.'
             in self.browser.contents)
         # Even with the correct firstname we can't register if a
@@ -815,5 +813,5 @@
 
 class DocumentUITests(CustomersFullSetup):
-    # Tests for CustomerSampleDocument relates views and pages
+    # Tests for customer document related views and pages
 
     def test_manage_document(self):
@@ -877,15 +875,21 @@
 
         self.assertTrue(
+            'INFO - system - K1000000 - d101 - Document created'
+            in logcontent)
+        self.assertTrue(
+            'INFO - zope.mgr - customers.browser.DocumentAddFormPage '
+            '- K1000000 - added: PDF Document %s'
+            % document.document_id in logcontent)
+        self.assertTrue(
             'INFO - zope.mgr - customers.browser.DocumentManageFormPage '
             '- K1000000 - d102 - saved: title'
             in logcontent)
         self.assertTrue(
-            'INFO - zope.mgr - customers.browser.DocumentAddFormPage '
-            '- K1000000 - added: PDF Document %s'
-            % document.document_id in logcontent)
+            'INFO - zope.mgr - K1000000 - d102 - Submitted for verification'
+            in logcontent)
         self.assertTrue(
             'INFO - zope.mgr - customers.browser.DocumentsManageFormPage '
-            '- K1000000 - removed: %s'
-            % document.document_id in logcontent)
+            '- K1000000 - removed: d102'
+            in logcontent)
 
     def test_edit_sample_document(self):
@@ -1128,5 +1132,5 @@
 
 class ContractUITests(CustomersFullSetup):
-    # Tests for CustomerSampleContract relates views and pages
+    # Tests for contract related views and pages
 
     def test_manage_contract(self):
@@ -1176,15 +1180,24 @@
         logcontent = open(logfile).read()
         self.assertTrue(
+            'INFO - zope.mgr - K1000000 - c102 - Contract created'
+            in logcontent)
+        self.assertTrue(
+            'INFO - zope.mgr - customers.browser.ContractAddFormPage '
+            '- K1000000 - added: Sample Contract %s'
+            % contract.contract_id in logcontent)
+        self.assertTrue(
             'INFO - zope.mgr - customers.browser.ContractManageFormPage '
             '- K1000000 - c102 - saved: title'
             in logcontent)
         self.assertTrue(
-            'INFO - zope.mgr - customers.browser.ContractAddFormPage '
-            '- K1000000 - added: Sample Contract %s'
-            % contract.contract_id in logcontent)
+            'INFO - zope.mgr - K1000000 - c102 - Submitted for approval'
+            in logcontent)
+        self.assertTrue(
+            'INFO - zope.mgr - K1000000 - c102 - Approved'
+            in logcontent)
         self.assertTrue(
             'INFO - zope.mgr - customers.browser.ContractsManageFormPage '
-            '- K1000000 - removed: %s'
-            % contract.contract_id in logcontent)
+            '- K1000000 - removed: c102'
+            in logcontent)
 
     def test_edit_sample_contract(self):
Index: main/waeup.ikoba/trunk/src/waeup/ikoba/customers/tests/test_contract.py
===================================================================
--- main/waeup.ikoba/trunk/src/waeup/ikoba/customers/tests/test_contract.py	(revision 12220)
+++ main/waeup.ikoba/trunk/src/waeup/ikoba/customers/tests/test_contract.py	(revision 12221)
@@ -88,4 +88,4 @@
         IWorkflowInfo(doc).fireTransition('create')
         messages = ' '.join(doc.history.messages)
-        self.assertTrue('Contract record created by system' in messages)
+        self.assertTrue('Contract created by system' in messages)
         return
Index: main/waeup.ikoba/trunk/src/waeup/ikoba/customers/tests/test_export.py
===================================================================
--- main/waeup.ikoba/trunk/src/waeup/ikoba/customers/tests/test_export.py	(revision 12220)
+++ main/waeup.ikoba/trunk/src/waeup/ikoba/customers/tests/test_export.py	(revision 12221)
@@ -94,5 +94,5 @@
             'sex,suspended,suspended_comment,password,state,history\r\n'
             'A111111,anna@sample.com,Anna,Tester,M.,+234-123-12345#,123,,0,,,'
-            'created,[u\'2014-12-04 11:25:35 UTC - Customer record created '
+            'created,[u\'2014-12-04 11:25:35 UTC - Customer created '
             'by system\']\r\n',
             result
@@ -274,5 +274,5 @@
 
             'SampleContract,sample,c101,d101,[u\'2014-12-04 12:10:46 UTC - '
-            'Contract record created by system\'],,'
+            'Contract created by system\'],,'
             'SAM,created,My Contract\r\n',
             result
@@ -293,5 +293,5 @@
 
             'SampleContract,sample,c101,d101,[u\'2014-12-04 12:10:46 UTC - '
-            'Contract record created by system\'],,'
+            'Contract created by system\'],,'
             'SAM,created,My Contract\r\n',
             result
@@ -312,5 +312,5 @@
 
             'SampleContract,sample,c101,d101,[u\'2014-12-04 12:10:46 UTC - '
-            'Contract record created by system\'],,'
+            'Contract created by system\'],,'
             'SAM,created,My Contract\r\n',
             result
Index: main/waeup.ikoba/trunk/src/waeup/ikoba/customers/workflow.py
===================================================================
--- main/waeup.ikoba/trunk/src/waeup/ikoba/customers/workflow.py	(revision 12220)
+++ main/waeup.ikoba/trunk/src/waeup/ikoba/customers/workflow.py	(revision 12221)
@@ -46,5 +46,5 @@
         source = None,
         condition = NullCondition,
-        msg = _('Customer record created'),
+        msg = _('Customer created'),
         destination = CREATED),
 
@@ -150,8 +150,8 @@
     Transition(
         transition_id = 'create',
-        title = _('Create contract record'),
+        title = _('Create contract'),
         source = None,
         condition = NullCondition,
-        msg = _('Contract record created'),
+        msg = _('Contract created'),
         destination = CREATED),
 
@@ -254,5 +254,6 @@
     try:
         customers_container = grok.getSite()['customers']
-        customers_container.logger.info('%s - %s' % (obj.customer_id,msg))
+        customers_container.logger.info(
+            '%s - %s - %s' % (obj.customer.customer_id, obj.contract_id, msg))
     except (TypeError, AttributeError):
         pass
@@ -370,5 +371,6 @@
     try:
         customers_container = grok.getSite()['customers']
-        customers_container.logger.info('%s - %s' % (obj.customer_id,msg))
+        customers_container.logger.info(
+            '%s - %s - %s' % (obj.customer.customer_id, obj.document_id, msg))
     except (TypeError, AttributeError):
         pass