Index: /main/kofacustom.pcn/trunk/src/kofacustom/pcn/applicants/export.py
===================================================================
--- /main/kofacustom.pcn/trunk/src/kofacustom/pcn/applicants/export.py	(revision 12233)
+++ /main/kofacustom.pcn/trunk/src/kofacustom/pcn/applicants/export.py	(revision 12234)
@@ -20,8 +20,8 @@
 import grok
 from waeup.kofa.applicants.interfaces import IApplicantBaseData
-from waeup.kofa.applicants.export import ApplicantsExporter
+from waeup.kofa.applicants.export import ApplicantExporter
 from kofacustom.pcn.applicants.interfaces import ICustomApplicant
 
-class CustomApplicantsExporter(ApplicantsExporter):
+class CustomApplicantExporter(ApplicantExporter):
     """Exporter for Custom Applicants.
     """
Index: /main/kofacustom.pcn/trunk/src/kofacustom/pcn/applicants/interfaces.py
===================================================================
--- /main/kofacustom.pcn/trunk/src/kofacustom/pcn/applicants/interfaces.py	(revision 12233)
+++ /main/kofacustom.pcn/trunk/src/kofacustom/pcn/applicants/interfaces.py	(revision 12234)
@@ -51,13 +51,4 @@
     state, depending on use-case.
     """
-
-    def writeLogMessage(view, comment):
-        """Adds an INFO message to the log file
-        """
-
-    def createStudent():
-        """Create a student object from applicatnt data
-        and copy applicant object.
-        """
 
     history = Attribute('Object history, a list of messages')
Index: /main/kofacustom.pcn/trunk/src/kofacustom/pcn/applicants/tests/test_browser.py
===================================================================
--- /main/kofacustom.pcn/trunk/src/kofacustom/pcn/applicants/tests/test_browser.py	(revision 12233)
+++ /main/kofacustom.pcn/trunk/src/kofacustom/pcn/applicants/tests/test_browser.py	(revision 12234)
@@ -29,5 +29,5 @@
 from waeup.kofa.applicants.tests.test_browser import ApplicantsFullSetup
 from waeup.kofa.applicants.tests.test_batching import ApplicantImportExportSetup
-from kofacustom.pcn.applicants.export import CustomApplicantsExporter
+from kofacustom.pcn.applicants.export import CustomApplicantExporter
 from kofacustom.pcn.applicants.batching import CustomApplicantProcessor
 
@@ -37,10 +37,10 @@
     layer = FunctionalLayer
 
-class ApplicantsExporterTest(ApplicantImportExportSetup):
+class ApplicantExporterTest(ApplicantImportExportSetup):
 
     layer = FunctionalLayer
 
     def setUp(self):
-        super(ApplicantsExporterTest, self).setUp()
+        super(ApplicantExporterTest, self).setUp()
         self.outfile = os.path.join(self.workdir, 'myoutput.csv')
         self.cat = getUtility(ICatalog, name='applicants_catalog')
@@ -76,5 +76,5 @@
         # set values we can expect in export file
         self.applicant = self.setup_applicant(self.applicant)
-        exporter = CustomApplicantsExporter()
+        exporter = CustomApplicantExporter()
         exporter.export_all(self.app, self.outfile)
         result = open(self.outfile, 'rb').read()
@@ -110,4 +110,5 @@
         num_succ, num_fail, finished_path, failed_path = result
         #content = open(failed_path).read()
+
         self.assertEqual(num_succ,1)
         self.assertEqual(num_fail,0)
Index: /main/kofacustom.pcn/trunk/src/kofacustom/pcn/browser/pages.py
===================================================================
--- /main/kofacustom.pcn/trunk/src/kofacustom/pcn/browser/pages.py	(revision 12233)
+++ /main/kofacustom.pcn/trunk/src/kofacustom/pcn/browser/pages.py	(revision 12234)
@@ -28,5 +28,5 @@
     ICustomSessionConfiguration, ICustomSessionConfigurationAdd)
 
-from kofacustom.pcn.university.faculty import IDepartment, IFaculty
+from kofacustom.pcn.university.faculty import ICustomDepartment, ICustomFaculty
 
 grok.templatedir('templates')
@@ -46,10 +46,10 @@
     """ Page form to add a new faculty to a faculty container.
     """
-    form_fields = grok.AutoFields(IFaculty)
+    form_fields = grok.AutoFields(ICustomFaculty)
 
 class FacultyManageFormPage(FacultyManageFormPage):
     """Manage the basic properties of a `Faculty` instance.
     """
-    form_fields = grok.AutoFields(IFaculty).omit('code')
+    form_fields = grok.AutoFields(ICustomFaculty).omit('code')
 
 class DepartmentPage(DepartmentPage):
@@ -61,5 +61,5 @@
     """
     grok.template('departmentmanagepage')
-    form_fields = grok.AutoFields(IDepartment).omit(
+    form_fields = grok.AutoFields(ICustomDepartment).omit(
         'code', 'score_editing_disabled')
 
@@ -67,5 +67,5 @@
     """Department index page.
     """
-    form_fields = grok.AutoFields(IDepartment).omit('score_editing_disabled')
+    form_fields = grok.AutoFields(ICustomDepartment).omit('score_editing_disabled')
 
 class CertificatePage(CertificatePage):
Index: /main/kofacustom.pcn/trunk/src/kofacustom/pcn/locales/en/LC_MESSAGES/waeup.kofa.po
===================================================================
--- /main/kofacustom.pcn/trunk/src/kofacustom/pcn/locales/en/LC_MESSAGES/waeup.kofa.po	(revision 12233)
+++ /main/kofacustom.pcn/trunk/src/kofacustom/pcn/locales/en/LC_MESSAGES/waeup.kofa.po	(revision 12234)
@@ -326,2 +326,5 @@
 msgid "Integer used for constructing the next matriculation number"
 msgstr " "
+
+msgid "First Choice"
+msgstr "Desired License"
Index: /main/kofacustom.pcn/trunk/src/kofacustom/pcn/students/export.py
===================================================================
--- /main/kofacustom.pcn/trunk/src/kofacustom/pcn/students/export.py	(revision 12233)
+++ /main/kofacustom.pcn/trunk/src/kofacustom/pcn/students/export.py	(revision 12234)
@@ -25,5 +25,5 @@
     ICustomStudentOnlinePayment)
 from waeup.kofa.students.export import (
-    StudentsExporter,
+    StudentExporter,
     StudentStudyCourseExporter,
     StudentStudyLevelExporter,
@@ -32,5 +32,5 @@
 from waeup.kofa.utils.helpers import iface_names
 
-class CustomStudentsExporter(StudentsExporter):
+class CustomStudentExporter(StudentExporter):
     """Exporter for Students.
     """
Index: /main/kofacustom.pcn/trunk/src/kofacustom/pcn/students/tests/test_export.py
===================================================================
--- /main/kofacustom.pcn/trunk/src/kofacustom/pcn/students/tests/test_export.py	(revision 12233)
+++ /main/kofacustom.pcn/trunk/src/kofacustom/pcn/students/tests/test_export.py	(revision 12234)
@@ -7,14 +7,14 @@
 from kofacustom.pcn.utils.utils import CustomKofaUtils
 from kofacustom.pcn.students.export import (
-    CustomStudentsExporter, CustomStudentPaymentsExporter)
+    CustomStudentExporter, CustomStudentPaymentsExporter)
 from kofacustom.pcn.testing import FunctionalLayer
 
 
-class CustomStudentsExporterTest(StudentImportExportSetup):
+class CustomStudentExporterTest(StudentImportExportSetup):
 
     layer = FunctionalLayer
 
     def setUp(self):
-        super(CustomStudentsExporterTest, self).setUp()
+        super(CustomStudentExporterTest, self).setUp()
         self.setup_for_export()
         result_entry = ResultEntry(
@@ -32,7 +32,7 @@
     def test_ifaces(self):
         # make sure we fullfill interface contracts
-        obj = CustomStudentsExporter()
+        obj = CustomStudentExporter()
         verifyObject(ICSVExporter, obj)
-        verifyClass(ICSVExporter, CustomStudentsExporter)
+        verifyClass(ICSVExporter, CustomStudentExporter)
         return
 
@@ -42,5 +42,5 @@
         # set values we can expect in export file
         self.setup_student(self.student)
-        exporter = CustomStudentsExporter()
+        exporter = CustomStudentExporter()
         exporter.export_all(self.app, self.outfile)
         result = open(self.outfile, 'rb').read()
@@ -90,6 +90,6 @@
             'p_item,p_level,p_session,p_state,payment_date,r_amount_approved,'
             'r_code,r_desc,student_id,state,current_session\r\n666,'
-            '12.12,2012-04-01 13:12:01,schoolfee,1,my-id,p-item,'
-            '100,2012,paid,2012-04-01 14:12:01,12.12,r-code,,'
+            '12.12,2012-04-01 13:12:01#,schoolfee,1,my-id,p-item,'
+            '100,2012,paid,2012-04-01 14:12:01#,12.12,r-code,,'
             'A111111,created,2012\r\n',
             result
Index: /main/kofacustom.pcn/trunk/src/kofacustom/pcn/university/batching.py
===================================================================
--- /main/kofacustom.pcn/trunk/src/kofacustom/pcn/university/batching.py	(revision 12233)
+++ /main/kofacustom.pcn/trunk/src/kofacustom/pcn/university/batching.py	(revision 12234)
@@ -1,7 +1,7 @@
 from waeup.kofa.university.batching import FacultyProcessor
-from kofacustom.pcn.university.faculty import IFaculty
+from kofacustom.pcn.university.faculty import ICustomFaculty
 
 class FacultyProcessor(FacultyProcessor):
     """A batch processor for IFaculty objects.
     """
-    iface = IFaculty
+    iface = ICustomFaculty
Index: /main/kofacustom.pcn/trunk/src/kofacustom/pcn/university/faculty.py
===================================================================
--- /main/kofacustom.pcn/trunk/src/kofacustom/pcn/university/faculty.py	(revision 12233)
+++ /main/kofacustom.pcn/trunk/src/kofacustom/pcn/university/faculty.py	(revision 12234)
@@ -24,5 +24,5 @@
 
 
-class IFaculty(IKofaContainer):
+class ICustomFaculty(IKofaContainer):
     """Representation of a university faculty.
     """
@@ -61,5 +61,5 @@
     """A university faculty.
     """
-    grok.implements(IFaculty)
+    grok.implements(ICustomFaculty)
 
     local_roles = [
@@ -91,5 +91,5 @@
         return implementedBy(CustomFaculty)
 
-class IDepartment(IKofaObject):
+class ICustomDepartment(IKofaObject):
     """Representation of a department.
     """
@@ -126,8 +126,9 @@
     certificates = Attribute("A container for certificates.")
 
+
 class CustomDepartment(Department):
     """A university department.
     """
-    grok.implements(IDepartment)
+    grok.implements(ICustomDepartment)
 
     local_roles = [
Index: /main/kofacustom.pcn/trunk/src/kofacustom/pcn/utils/utils.py
===================================================================
--- /main/kofacustom.pcn/trunk/src/kofacustom/pcn/utils/utils.py	(revision 12233)
+++ /main/kofacustom.pcn/trunk/src/kofacustom/pcn/utils/utils.py	(revision 12234)
@@ -31,4 +31,5 @@
     STUDY_MODES_DICT = {
         'na': 'not applicable',
+        'ug_ft': 'not applicable',
         }
 
@@ -40,8 +41,10 @@
         'pmrp': 'Pharmaceutical and Medical Representative Permit',
         'sop': 'Scientific Office Permit',
+        'basic': 'Not applicable',
         }
 
     PAYMENT_CATEGORIES = {
         'application': 'Registration Fee',
+        'schoolfee': 'Not applicable',
         }
 